"use strict";

const { exec } = require("child_process");
var childProcess = require("child_process");
var cut_file = require("./random_gen").cut_file;
const puppeteer = require("puppeteer");
const Server = require("ws").Server;
const args = require("yargs")
.usage("Usage : load_content.js -file file_path -n amount")
.demandOption(["file"])
.demandOption(["n"])
.alias("f", "file")
.alias("l", "link")
.describe("file", "file containing content, data must follow the CSV standard")
.describe("link", "link to website treating the data, defaults to Mynij")
.describe("n", "number of parallel indices to add the content to")
.nargs("n", 1)
.nargs("file", 1)
.nargs("link", 1)
.argv;

var link = args.link
? args.link
: "https://softinst115787.host.vifib.net/public/unit_tests/" +
                            "add_multiple_indices.html";

var files;
var browser;
var page;
var n = 0;
var time;
var monitor;
var args_to_pass = [];
args_to_pass.push("-n");

function init_server (){
  var port = 9030;
  var ws = new Server({port: port});
  ws.on("connection", function(w){
    w.on("message", function(){
      process.send(n + "," + Date.now());
      query();
    });
    w.on("close", function() {
      ws.close();
    });
  });
}

function timeout (){
  //Every 30 minutes, check if more than 2 hours have passed since last response
  setTimeout(function () {
    if (Date.now() - time > 7200000){ //2 hours
      process.send(n + ",Timeout error \n");
      files = [];
      query();
    } else {
      timeout();
    }
  }, 1800000); //30 minutes
}

async function query (){
  if (files.length === 0){
    monitor.kill();
    var ipc=require("node-ipc");
    ipc.config.silent = true;
    ipc.connectTo("main");
    ipc.of.main.emit("message", "DONE");
    return;
  } else {
    n += 1000;
    time = Date.now();
    const [fileChooser] = await Promise.all([
      page.waitForFileChooser(),
      page.click("input#load")
    ]);
    await fileChooser.accept([files.shift()]);
  }
}

(async () => {

  files = cut_file(args.file, 1000);
  init_server();
  browser = await puppeteer.launch();
  page = await browser.newPage();
  await page.goto(link);
  await page.focus("#amount");
  await page.keyboard.type(args.n.toString());
  await page.$eval('#done', el => el.click());

  exec("ps x | grep \"chrome\"", (error, stdout, stderr) => {
     args_to_pass.push("-p");
     var pids = "";
     var processes = stdout.split("\n");
     processes.forEach((item) => {
       if (!item.includes("grep")) pids += item.trim().split(" ")[0] + " "
     });

     args_to_pass.push(pids.trim());
     monitor = childProcess.fork("./unit_tests/monitor.js", args_to_pass);
     timeout();
     query();
   });

})();
